package eu.etaxonomy.taxeditor.designproposal2.controller;

import org.eclipse.jface.action.Action;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.PartInitException;

import eu.etaxonomy.taxeditor.designproposal2.Activator;
import eu.etaxonomy.taxeditor.designproposal2.model.NameEditorInput;
import eu.etaxonomy.taxeditor.designproposal2.model.TaxonName;
import eu.etaxonomy.taxeditor.designproposal2.view.MultiPagePilosellaView;

public class OpenNameEditorAction extends Action {

	private TaxonName taxonname;
	public static final String ID = "eu.etaxonomy.taxeditor.designproposal2.controller.opennameeditoraction"; //$NON-NLS-1$
	
	public OpenNameEditorAction(TaxonName taxonname) {
		this.taxonname = taxonname;
	}

	public OpenNameEditorAction() {
//		INameService ns = Activator.getDefault().getApplicationController().getNameService();
//		this.taxonname = ns.createTaxonName(null);
		this.taxonname = new TaxonName();
		this.taxonname.setName("new");
		setId(ID);
		setText("New taxon");
	}

	public OpenNameEditorAction(String name) {
//		INameService ns = Activator.getDefault().getApplicationController().getNameService();
//		this.taxonname = ns.createTaxonName(null);
		this.taxonname = new TaxonName();
		this.taxonname.setName(name);
//		setId(ID);
//		setText("New name");
	}
	
	public void run() {
		IEditorInput input = new NameEditorInput(taxonname);
        try {
//        	Activator.getDefault().getWorkbench().getActiveWorkbenchWindow().
//        		getActivePage().openEditor(input, NameEditorView.ID);
        	Activator.getDefault().getWorkbench().getActiveWorkbenchWindow().
    			getActivePage().openEditor(input, MultiPagePilosellaView.ID);   	
		} catch (PartInitException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}