package eu.etaxonomy.taxeditor.prototype2.view.nameviewersupport;

import java.util.Scanner;

import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.DocumentEvent;
import org.eclipse.jface.text.IDocumentListener;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

import eu.etaxonomy.taxeditor.prototype2.view.NameEditorView;

/**
 * This listener catches all line breaks other than carriage
 *  returns at end-of-line, and creates new name viewers,
 *  for instance, if user pastes a block of taxon information.  
 * 
 * @author p.ciardelli
 *
 */
public class NameDocumentListener implements IDocumentListener {

	
	/**
	 * the View on which createdRelatedName gets called in case of line breaks 
	 */
	private NameEditorView nameEditorView;
	/**
	 * the Control after which any new related names are created  
	 */	
	private Control control;
	/**
	 * the Composite that is resized after any change  
	 */	
	private Composite parent;
	
	public NameDocumentListener(NameEditorView nameEditorView, Control control,
			Composite parent) {
		this.nameEditorView = nameEditorView;
		this.control = control;
		this.parent = parent;
	}

	public void documentAboutToBeChanged(DocumentEvent e) {

		String text = e.getText();
		System.out.println("b4: " + e.getText());
		
		e.fText = "yo";
		System.out.println("aft: " + e.getText());
		
//		int length = e.getLength();
//		int offset = e.getOffset();
//		int docLength = e.getDocument().getLength(); // length of doc BEFORE insert
//				
//		if (text.contains(System.getProperty("line.separator"))) {
//			
//			if (offset < docLength) {
			// remove text following insert from document,
			//  add to insert text	 
//				try {
//					text += e.getDocument().get(offset, docLength - offset);
//					e.getDocument().replace(offset, docLength - offset, "");
//				} catch (BadLocationException e1) {
//					System.out.println(e1.getMessage());
//					e1.printStackTrace();
//				}
//			}	
//						
//			
//			
//			Scanner scanner = new Scanner( text );
//			scanner.useDelimiter (System.getProperty("line.separator"));
//			
//			StyledText SText = (StyledText) control;
//			nameEditorView.createRelatedName(SText, "test");
//			StyledText lastSText = null;
//			while (scanner.hasNext()) {
//				if (lastSText == null)
//					e.getDocument().set(scanner.next());
//				else
//					SText = nameEditorView.createRelatedName(SText, scanner.next()).
//							getTextWidget();
//				lastSText = SText;
//			}	
//			
//			SText.setFocus();
//			
//			// put cursor at EOL of last sourceviewer
//			SText.setCaretOffset(SText.getText().length()); 
//			
//		}
		
	}
	
	public void documentChanged(DocumentEvent event) {
		
//		System.out.println("Offset: " + event.getOffset());
//		System.out.println("Get: " + event.getDocument().get());

		String text = event.getDocument().get();
				
		if (text.endsWith(System.getProperty("line.separator"))) {
			event.getDocument().set(text.trim());
			nameEditorView.createRelatedName(control,"help");
		}
//		
//		int breakOffset = text.indexOf(System.getProperty("line.separator"));
//		if (breakOffset > -1) {
//			try {
//				event.getDocument().replace(breakOffset, text.length() - breakOffset, "");
//			} catch (BadLocationException e) {
//				// TODO Auto-generated catch block
//				System.out.println(e.getMessage());
//				e.printStackTrace();
//			}
//		}

//		if (event.getDocument().get().contains(System.getProperty("line.separator"))) {
//			Scanner scanner = new Scanner(event.getDocument().get());
//			scanner.useDelimiter (System.getProperty("line.separator"));
//			try {
//				event.getDocument().replace(
//						0, event.getDocument().get().length(), scanner.next());
//			} catch (BadLocationException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
////		document.set(scanner.next());
//		
//			while (scanner.hasNext()) {
//				System.out.println("Create new relname with: " + scanner.next());
//			}
//		}		
		
		// re-draw parent in case text controls need re-sizing -
		//  could also be the case if databinding has modified text
//		nameEditorView.createRelatedName(control,"help");
		
//		parent.getParent().layout();		
	}
}
