package eu.etaxonomy.taxeditor.prototype2.view.nameviewersupport;

import java.util.Scanner;

import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.DocumentEvent;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IDocumentPartitioner;
import org.eclipse.jface.text.ITypedRegion;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.widgets.Control;

import eu.etaxonomy.taxeditor.prototype2.view.NameEditorView;

public class SimpleNamePartitioner implements IDocumentPartitioner {

	private NameEditorView nameEditorView;
	private Control precedingControl;
	
	public SimpleNamePartitioner(NameEditorView nameEditorView, Control precedingControl) {
		this.nameEditorView = nameEditorView;
		this.precedingControl = precedingControl;		
	}
	
	public ITypedRegion[] computePartitioning(int offset, int length) {
		// TODO Auto-generated method stub
		return null;
	}

	public void connect(IDocument document) {
		// TODO Auto-generated method stub

	}

	public void disconnect() {
		// TODO Auto-generated method stub

	}

	public void documentAboutToBeChanged(DocumentEvent e) {

		String text = e.getText();
		int length = e.getLength();
		int offset = e.getOffset();
		int docLength = e.getDocument().getLength(); // length of doc BEFORE insert
		
		if (text.contains(System.getProperty("line.separator"))) {
			if (offset < docLength) {
	//		 remove text following insert from document,
	//		  add to insert text	 
				try {
					text += e.getDocument().get(offset, docLength - offset);
					e.getDocument().replace(offset, docLength - offset, "");
				} catch (BadLocationException e1) {
					System.out.println(e1.getMessage());
					e1.printStackTrace();
				}
			}	
			
			Scanner scanner = new Scanner( text );
			scanner.useDelimiter (System.getProperty("line.separator"));
			
			StyledText SText = (StyledText) precedingControl;
			nameEditorView.createRelatedName(SText, "test");
			StyledText lastSText = null;
			while (scanner.hasNext()) {
				if (lastSText == null)
					e.getDocument().set(scanner.next());
				else
					SText = nameEditorView.createRelatedName(SText, scanner.next()).
							getTextWidget();
				lastSText = SText;
			}	
			
			SText.setFocus();
			
			// put cursor at EOL of last sourceviewer
			SText.setCaretOffset(SText.getText().length()); 
		}
	}

	public boolean documentChanged(DocumentEvent event) {
		// TODO Auto-generated method stub
		return false;
	}

	public String getContentType(int offset) {
		// TODO Auto-generated method stub
		return null;
	}

	public String[] getLegalContentTypes() {
		// TODO Auto-generated method stub
		return null;
	}

	public ITypedRegion getPartition(int offset) {
		// TODO Auto-generated method stub
		return null;
	}

}
