package eu.etaxonomy.taxeditor.editor;

import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import eu.etaxonomy.taxeditor.TaxEditorPlugin;

public class UndoView extends ViewPart {

	public static final String ID = "eu.etaxonomy.taxeditor.editor.undoview"; //$NON-NLS-1$
    private Table table;

    /**
	 * Create contents of the view part
	 * @param parent
	 */
	@Override
	public void createPartControl(Composite parent) {
		Composite container = new Composite(parent, SWT.NONE);
		container.setLayout(new FillLayout(SWT.VERTICAL));

		table = new Table(container, SWT.NONE);
		table.getHorizontalBar().setVisible(false);
		table.setLinesVisible(true);

		final TableColumn newColumnTableColumn = new TableColumn(table, SWT.NONE);
		newColumnTableColumn.setWidth(19);

		final TableColumn newColumnTableColumn_1 = new TableColumn(table, SWT.NONE);
		newColumnTableColumn_1.setWidth(1000);
		newColumnTableColumn_1.setText("New column");

		final TableItem newItemTableItem = new TableItem(table, SWT.BORDER);
		newItemTableItem.setText(1, "Created taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");

		final TableItem newItemTableItem_1 = new TableItem(table, SWT.BORDER);
		newItemTableItem_1.setText(1, "Added fact (Distribution) \"California deciduous forest ...\" to \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");

		final TableItem newItemTableItem_2 = new TableItem(table, SWT.BORDER);
		newItemTableItem_2.setText(1, "Added fact (Distribution) \"Brazilian (Northerly region)\" to \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");

		final TableItem newItemTableItem_3 = new TableItem(table, SWT.BORDER);
		newItemTableItem_3.setText(1, "Moved taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\" to \"Pilosella fuscoatra coll.\"");

		final TableItem newItemTableItem_4 = new TableItem(table, SWT.BORDER);
		newItemTableItem_4.setText(1, "Added unknown syn. \"Hieracium fuscoatrum Ngeli & Peter\" to \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");

		final TableItem newItemTableItem_5 = new TableItem(table, SWT.BORDER);
		newItemTableItem_5.setText(1, "Changed rel. type to homo. syn. for \"Hieracium fuscoatrum Ngeli & Peter\" to \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");

		final TableItem newItemTableItem_6 = new TableItem(table, SWT.BORDER);
		newItemTableItem_6.setText(1, "Edited name \"Hieracium fuscoatrum Ngeli & Peter\" to \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");

		final TableItem newItemTableItem_7 = new TableItem(table, SWT.BORDER);
		newItemTableItem_7.setText(new String[] {"Undo the last action"});
		newItemTableItem_7.setImage(0, ResourceManager.getPluginImage(TaxEditorPlugin.getDefault(), "icons/undo.gif"));
		newItemTableItem_7.setText(1, "Deleted fact (Distribution) \"Brazilian (Northerly region)\" to \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");
		//
		createActions();
		initializeToolBar();
		initializeMenu();
	}

	/**
	 * Create the actions
	 */
	private void createActions() {
		// Create the actions
	}

	/**
	 * Initialize the toolbar
	 */
	private void initializeToolBar() {
		IToolBarManager toolbarManager = getViewSite().getActionBars()
				.getToolBarManager();
	}

	/**
	 * Initialize the menu
	 */
	private void initializeMenu() {
		IMenuManager menuManager = getViewSite().getActionBars()
				.getMenuManager();
	}

	@Override
	public void setFocus() {
		// Set the focus
	}

}
