// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.annotatedlineeditor;

import java.util.Comparator;

import org.apache.log4j.Logger;

import eu.etaxonomy.cdm.model.common.IdentifiableEntity;

/**
 * @author p.ciardelli
 * @created 19.08.2009
 * @version 1.0
 */
public class IdentifiableEntityComparator implements Comparator {
	private static final Logger logger = Logger
			.getLogger(IdentifiableEntityComparator.class);
	
    private boolean fIgnoreCase;

	private String getTitleCache(Object o) {
		return o == null || !(o instanceof IdentifiableEntity) ? 
				null : ((IdentifiableEntity) o).getTitleCache();
	}
	
	/* (non-Javadoc)
	 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
	 */
	public int compare(Object o1, Object o2) {
		String titleCache1 = getTitleCache(o1);
		String titleCache2 = getTitleCache(o2);
		if (titleCache1 == null && titleCache2 == null) {
			return 0;
		}
		if (titleCache1 == null) {
			return -1;
		}
		if (titleCache2 == null) {
			return 1;
		}				
        return fIgnoreCase ? titleCache1.compareToIgnoreCase(titleCache2) : 
        						titleCache1.compareTo(titleCache2);
	}
}
