/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.description.CommonTaxonName;
import eu.etaxonomy.taxeditor.forms.LanguageComboComposite;
import eu.etaxonomy.taxeditor.forms.TextWithLabelComposite;

/**
 * @author nho
 *
 */
public class CommonNameSection extends AbstractDescriptionDetailSection implements ModifyListener, SelectionListener{

	LanguageComboComposite languageCombo;
	TextWithLabelComposite commonName;
	
	/**
	 * @param parent
	 * @param page
	 * @param style
	 */
	public CommonNameSection(Composite parent,
			AbstractDescriptionDetailsPage page, int style) {
		super(parent, page, style);
		
		setText("Common Name Details");
		
		languageCombo = toolkit.createLanguageComboComposite(getClient(), "Language", null, SWT.WRAP);
		languageCombo.addSelectionListener(this);
		languageCombo.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false));
		commonName = toolkit.createTextWithLabelComposite(getClient(), "Common Name", null, SWT.WRAP);
		commonName.addModifyListener(this);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#updateSection()
	 */
	@Override
	public void updateSection() {
		languageCombo.setSelection(getDescriptionElement().getLanguage());
		commonName.setText(getDescriptionElement().getName());
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#modifyText(org.eclipse.swt.events.ModifyEvent)
	 */
	@Override
	public void modifyText(ModifyEvent e) {
		super.modifyText(e);
		getDescriptionElement().setName(commonName.getText());
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
	 */
	public void widgetSelected(SelectionEvent e) {
		page.fireStateChanged();
		getDescriptionElement().setLanguage(languageCombo.getSelection());
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#getDescriptionElement()
	 */
	@Override
	public CommonTaxonName getDescriptionElement() {
		return (CommonTaxonName) super.getDescriptionElement();
	}

	// not used
	public void widgetDefaultSelected(SelectionEvent e) {}
}
