/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
import eu.etaxonomy.cdm.model.description.TaxonDescription;
import eu.etaxonomy.taxeditor.forms.MultilineTextWithLabel;
import eu.etaxonomy.taxeditor.model.DescriptionHelper;

/**
 * @author n.hoffmann
 * @author p.ciardelli
 */
public class LabelDetailsSection extends AbstractDescriptionDetailSection {

	private MultilineTextWithLabel detailDescription;
	
	/**
	 * @param parent
	 * @param page
	 * @param style
	 */
	public LabelDetailsSection(Composite parent,
			AbstractDescriptionDetailsPage page,
			String title, String labelString, int style) {
		super(parent, page, style);
		setText(title);
		
		detailDescription = toolkit.createMultilineTextWithLabel(getClient(), labelString, 100, SWT.WRAP);
		detailDescription.addModifyListener(this);
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#updateSection()
	 */
	@Override
	public void updateSection() {
		detailDescription.setText(getLabel());
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#modifyText(org.eclipse.swt.events.ModifyEvent)
	 */
	@Override
	public void modifyText(ModifyEvent e) {
		super.modifyText(e);
		saveLabel();
	}
	

	private void saveLabel() {
		if (page.input instanceof TaxonDescription) {
			((TaxonDescription) page.input).setTitleCache(detailDescription.getText());
		}
		if (page.input instanceof DescriptionElementBase) {
			DescriptionHelper.setCache((DescriptionElementBase) page.input, detailDescription.getText());
		}
	}
	
	private String getLabel() {
		if (page.input instanceof TaxonDescription) {
			return ((TaxonDescription) page.input).getTitleCache();
		}
		if (page.input instanceof DescriptionElementBase) {
			return DescriptionHelper.getCache((DescriptionElementBase) page.input);
		}
		return "";
	}
}
