/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.description.Feature;
import eu.etaxonomy.cdm.model.description.TaxonInteraction;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.forms.MultilineTextWithLabel;
import eu.etaxonomy.taxeditor.forms.TaxonSelectionComposite;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author nho
 *
 */
public class TaxonInteractionDetailsSection extends
		AbstractDescriptionDetailSection{

	private TaxonSelectionComposite taxonSelection;
	private MultilineTextWithLabel interactionDescription;

	/**
	 * @param parent
	 * @param page
	 * @param sectionStyle
	 */
	public TaxonInteractionDetailsSection(Composite parent,
			AbstractDescriptionDetailsPage page, int sectionStyle) {
		super(parent, page, sectionStyle);
		
		taxonSelection = toolkit.createTaxonSelectionComposite(getClient(), null, SWT.WRAP);
		taxonSelection.addModifyListener(this);
		
		interactionDescription = toolkit.createMultilineTextWithLabel(getClient(), "Description", 200, SWT.WRAP);
		interactionDescription.addModifyListener(this);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#updateSection()
	 */
	@Override
	public void updateSection() {
		Feature feature = getDescriptionElement().getFeature();
		this.setText(feature.getLabel() + " Details"); //$NON-NLS-1$
		
		taxonSelection.setSelection(getTaxonInteraction().getTaxon2());
		interactionDescription.setText(getTaxonInteraction().getDescription(CdmStore.getDefaultLanguage()));
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#modifyText(org.eclipse.swt.events.ModifyEvent)
	 */
	@Override
	public void modifyText(ModifyEvent e) {
		super.modifyText(e);
		getTaxonInteraction().addDescription(interactionDescription.getText(), CdmStore.getDefaultLanguage());
		getTaxonInteraction().setTaxon2((Taxon) taxonSelection.getSelection());
	}
	
	public TaxonInteraction getTaxonInteraction(){
		return (TaxonInteraction) getDescriptionElement();
	}

}
