/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.description.Feature;
import eu.etaxonomy.taxeditor.forms.MultilineTextWithLabel;
import eu.etaxonomy.taxeditor.model.DescriptionHelper;

/**
 * @author nho
 *
 */
public class TextDataSection extends AbstractDescriptionDetailSection{

	private MultilineTextWithLabel multilineTextWithLabel;
	
	/**
	 * @param parent
	 * @param page
	 * @param style
	 */
	public TextDataSection(Composite parent,
			AbstractDescriptionDetailsPage page, int style) {
		super(parent, page, style);
		
		multilineTextWithLabel = toolkit.createMultilineTextWithLabel(getClient(), "Text for this descriptive element:", 200, SWT.WRAP);
		
		multilineTextWithLabel.addModifyListener(this);
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#modifyText(org.eclipse.swt.events.ModifyEvent)
	 */
	@Override
	public void modifyText(ModifyEvent e) {
		super.modifyText(e);
		DescriptionHelper.setCache(getDescriptionElement(), multilineTextWithLabel.getText());
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#updateSection()
	 */
	@Override
	public void updateSection() {
		Feature feature = getDescriptionElement().getFeature();
		this.setText(feature.getLabel() + " Details"); //$NON-NLS-1$
		multilineTextWithLabel.setText(DescriptionHelper.getCache(page.getDescriptionElement()));
	}
}
