/**
 * 
 */
package eu.etaxonomy.taxeditor.forms;

import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.common.Annotation;

/**
 * @author nho
 *
 */
public class AnnotationComposite extends MultilineTextWithLabel implements ModifyListener{

	private Annotation annotation;

	/**
	 * 
	 * @param parent
	 * @param annotation
	 * @param style
	 */
	protected AnnotationComposite(Composite parent, Annotation annotation, int style) {
		super(parent, "Annotation", null, 100, style);
		
		this.setAnnotation(annotation);
		
		text.addModifyListener(this);
	}

	/**
	 * @param annotation the annotation to set
	 */
	public void setAnnotation(Annotation annotation) {
		this.annotation = annotation;
		setText(annotation.getText());
	}

	/**
	 * @return the annotation
	 */
	public Annotation getAnnotation() {
		return annotation;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ModifyListener#modifyText(org.eclipse.swt.events.ModifyEvent)
	 */
	public void modifyText(ModifyEvent e) {
		annotation.setText(getText());
	}
}
