/**
 * 
 */
package eu.etaxonomy.taxeditor.forms;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.common.DescriptionElementSource;

/**
 * @author  nho
 */
public class DescriptionElementSourceComposite extends FormComposite implements ModifyListener{

	private DescriptionElementSource source;
	
	private ReferenceSelectionComposite citationSelection;
	private TextWithLabelComposite microCitation;
	private NameSelectionComposite nameSelection;

	protected DescriptionElementSourceComposite(Composite parent, DescriptionElementSource source, int style){
		super(parent, style);
		this.source = source;
		
		citationSelection = new ReferenceSelectionComposite(this, "Citation", source.getCitation(), SWT.NULL);
		citationSelection.addModifyListener(this);
		
		microCitation = new TextWithLabelComposite(this, "Citation Detail", source.getCitationMicroReference(), SWT.NULL);
		microCitation.addModifyListener(this);
        
        nameSelection = new NameSelectionComposite(this, "Name in Source", source.getNameUsedInSource(), SWT.NULL);
        nameSelection.addModifyListener(this);
	}
	
	
	/**
	 * @return the source
	 */
	public DescriptionElementSource getSource() {
		return source;
	}


	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ModifyListener#modifyText(org.eclipse.swt.events.ModifyEvent)
	 */
	public void modifyText(ModifyEvent e) {
		source.setCitation(citationSelection.getSelection());
		source.setCitationMicroReference(microCitation.getText());
		source.setNameUsedInSource(nameSelection.getSelection());
	}	
}