package eu.etaxonomy.taxeditor.propertysheet;

import eu.etaxonomy.cdm.model.common.AnnotatableEntity;
import eu.etaxonomy.cdm.model.common.Annotation;

public class AnnotationPropertySource extends CollectionPropertySource {

	private AnnotatableEntity annotatableEntity;

	public AnnotationPropertySource(AnnotatableEntity annotatableEntity) {
		super(annotatableEntity.getAnnotations());
		
		this.annotatableEntity = annotatableEntity;
	}
	
	@Override
	protected String getItemDisplayName(Object item) {
		// No display names on individual annotations
		return "";
	}

	@Override
	public Object getPropertyValue(Object id) {
		if (id instanceof Annotation) {
			return ((Annotation) id).getText();
		}
		return null;
	}

	@Override
	public void setPropertyValue(Object id, Object value) {
		// Fields not editable in property sheet view
	}

	@Override
	public String toString() {
		// "Annotations" header has no value
		return "";
	}
}