package eu.etaxonomy.taxeditor.propertysheet;

import eu.etaxonomy.cdm.model.common.AnnotatableEntity;
import eu.etaxonomy.cdm.model.common.Annotation;
import eu.etaxonomy.cdm.model.common.Marker;

public class MarkerPropertySource extends CollectionPropertySource {

	private AnnotatableEntity annotatableEntity;

	public MarkerPropertySource(AnnotatableEntity annotatableEntity) {
		super(annotatableEntity.getMarkers());
		
		this.annotatableEntity = annotatableEntity;
	}
	
	@Override
	protected String getItemDisplayName(Object item) {
		// No display names on individual annotations
		return "";
	}

	@Override
	public Object getPropertyValue(Object id) {
		if (id instanceof Marker) {
			Marker marker = (Marker) id;
			String text = marker.getMarkerType().getLabel();
			text += " (" + marker.getFlag() + ")";
			return text;
		}
		return null;
	}

	@Override
	public void setPropertyValue(Object id, Object value) {
		// Fields not editable in property sheet view
	}

	@Override
	public String toString() {
		// "Annotations" header has no value
		return "";
	}
}