// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.propertysheet.tabbed;

import org.apache.log4j.Logger;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.api.conversation.IConversationEnabled;
import eu.etaxonomy.cdm.persistence.hibernate.CdmDataChangeMap;
import eu.etaxonomy.taxeditor.editor.AbstractTaxonEditor;

/**
 * @author n.hoffmann
 * @created 11.06.2009
 * @version 1.0
 */
public class EditorTabbedPropertySheetPage extends TabbedPropertySheetPage implements IConversationEnabled{

	private static final Logger logger = Logger
			.getLogger(EditorTabbedPropertySheetPage.class);
	
	private AbstractTaxonEditor editor;
	
	/**
	 * @param tabbedPropertySheetPageContributor
	 */
	public EditorTabbedPropertySheetPage(AbstractTaxonEditor tabbedPropertySheetPageContributor) {
		super(tabbedPropertySheetPageContributor);
		
		editor = tabbedPropertySheetPageContributor;

	}
	

	/* (non-Javadoc)
	 * @see org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage#setFocus()
	 */
	@Override
	public void setFocus() {
		super.setFocus();
		getConversationHolder().bind();
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.cdm.api.conversation.IConversationEnabled#getConversationHolder()
	 */
	public ConversationHolder getConversationHolder() {
		return editor.getConversationHolder();
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.cdm.persistence.hibernate.ICdmPostDataChangeObserver#update(eu.etaxonomy.cdm.persistence.hibernate.CdmDataChangeMap)
	 */
	public void update(CdmDataChangeMap changeEvents) {
		// TODO 
	}

	/**
	 * @return the editor
	 */
	public AbstractTaxonEditor getEditor() {
		return editor;
	}

}
