// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.io.wizard;

import java.io.File;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbench;

import eu.etaxonomy.cdm.io.tcsxml.out.TcsXmlExportConfigurator;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created 15.06.2009
 * @version 1.0
 */
public class TcsExportWizard extends AbstractExportWizard<TcsXmlExportConfigurator> {
	private static final Logger logger = Logger
			.getLogger(TcsExportWizard.class);
	private static final String TCS_EXPORT = "TCS_EXPORT";
	private TcsXmlExportConfigurator configurator;
	private ExportToFileDestinationWizardPage page;

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.Wizard#performFinish()
	 */
	@Override
	public boolean performFinish() {
		String urlString = page.getFolderText() + File.separator + page.getExportFileName();
		
		configurator.setDestination(new File(urlString));
		configurator.setCdmAppController(CdmStore.getApplicationControllerWillBeObsolete());
		
		return doExport(configurator);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchWizard#init(org.eclipse.ui.IWorkbench, org.eclipse.jface.viewers.IStructuredSelection)
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		configurator = TcsXmlExportConfigurator.NewInstance(null, null);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.io.AbstractExportWizard#getConfigurator()
	 */
	@Override
	public TcsXmlExportConfigurator getConfigurator() {
		return configurator;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.io.AbstractExportWizard#addPages()
	 */
	@Override
	public void addPages() {
		super.addPages();
		
		page = ExportToFileDestinationWizardPage.Tcs();
		addPage(page);
	}
	
	
}
