// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.model;

import java.util.Vector;

import eu.etaxonomy.cdm.persistence.hibernate.CdmDataChangeEvent;
import eu.etaxonomy.cdm.persistence.hibernate.CdmDataChangeMap;

/**
 * Reactions on specific EventyTypes are overridden here for convenience. 
 * 
 * @author n.hoffmann
 * @created 09.04.2009
 * @version 1.0
 */
public abstract class AbstractDataChangeBehaviour implements IDataChangeBehavior {

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.store.model.IDataChangeBehavior#reactOnDataChange(java.lang.Object, java.util.List)
	 */
	public abstract void reactOnDataChange(CdmDataChangeMap events);

	/** 
	 * Implementors should overwrite this method if needed
	 * 
	 * @see eu.etaxonomy.taxeditor.model.IDataChangeBehavior#reactOnDelete(java.lang.Object, eu.etaxonomy.cdm.persistence.hibernate.CdmDataChangeEvent)
	 */
	public void reactOnDelete(Vector<CdmDataChangeEvent> event) {}

	/** 
	 * Implementors should overwrite this method if needed
	 * 
	 * @see eu.etaxonomy.taxeditor.model.IDataChangeBehavior#reactOnInsert(java.lang.Object, eu.etaxonomy.cdm.persistence.hibernate.CdmDataChangeEvent)
	 */
	public void reactOnInsert(Vector<CdmDataChangeEvent> event) {}

	/** 
	 * Implementors should overwrite this method if needed
	 * 
	 * @see eu.etaxonomy.taxeditor.model.IDataChangeBehavior#reactOnUpdate(java.lang.Object, eu.etaxonomy.cdm.persistence.hibernate.CdmDataChangeEvent)
	 */
	public void reactOnUpdate(Vector<CdmDataChangeEvent> event) {}
}
